<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZExpansion: DayzExpansion/Quests/Scripts/4_world/dayzexpansion_quests/systems/quests/expansionquestpersistentserverdata.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZExpansion<span id="projectnumber">&#160;1.7.12</span>
   </div>
   <div id="projectbrief">DayZExpansion Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('d3/d90/a02177_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">expansionquestpersistentserverdata.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../d3/d90/a02177.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * ExpansionQuestPersistentServerData.c</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> *</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * DayZ Expansion Mod</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * www.dayzexpansion.com</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> * © 2022 DayZ Expansion Mod Team</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment"> *</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment"> * This work is licensed under the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License.</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment"> * To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-nd/4.0/.</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment"> *</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment">*/</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span> </div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno"><a class="line" href="../../d0/de9/a06465.html">   13</a></span><span class="keyword">class </span><a class="code hl_class" href="../../d0/de9/a06465.html">ExpansionQuestPersistentServerDataBase</a></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span>{</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno"><a class="line" href="../../d0/de9/a06465.html#acbd7f84a5493f997ee6165522c95226d">   15</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d0/de9/a06465.html#acbd7f84a5493f997ee6165522c95226d">ConfigVersion</a>;</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno"><a class="line" href="../../d0/de9/a06465.html#a88baee373ed33c7af4d8fa5d690273c0">   16</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d0/de9/a06465.html#a88baee373ed33c7af4d8fa5d690273c0">LastWeeklyReset</a>;</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno"><a class="line" href="../../d0/de9/a06465.html#a28e3631232f3c41f0875102d6f91d54b">   17</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d0/de9/a06465.html#a28e3631232f3c41f0875102d6f91d54b">LastDailyReset</a>;</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span>};</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span> </div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno"><a class="line" href="../../d6/d1b/a06469.html">   20</a></span><span class="keyword">class </span><a class="code hl_class" href="../../d6/d1b/a06469.html">ExpansionQuestPersistentServerData</a>: <a class="code hl_class" href="../../d0/de9/a06465.html">ExpansionQuestPersistentServerDataBase</a></div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span>{</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno"><a class="line" href="../../d6/d1b/a06469.html#aa4ffca8a2792420d7e2218608628b48b">   22</a></span>    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d6/d1b/a06469.html#aa4ffca8a2792420d7e2218608628b48b">CONFIGVERSION</a> = 0;</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span> </div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>    [NonSerialized()]</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno"><a class="line" href="../../d6/d1b/a06469.html#a2b950596474fa455a2a744e8d076da8d">   25</a></span>    <span class="keyword">static</span> <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d6/d1b/a06469.html#a2b950596474fa455a2a744e8d076da8d">DAY_TIME</a> = 86400; <span class="comment">//! Day in seconds</span></div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span>    [NonSerialized()]</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno"><a class="line" href="../../d6/d1b/a06469.html#aaec92cabe9ce47dffa1612a5b8467778">   27</a></span>    <span class="keyword">static</span> <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d6/d1b/a06469.html#aaec92cabe9ce47dffa1612a5b8467778">WEEK_TIME</a> = 604800; <span class="comment">//! Week in seconds</span></div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span> </div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno"><a class="line" href="../../d6/d1b/a06469.html#a62062703a8a8aa6caa46a2f0b531ef2c">   29</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d6/d1b/a06469.html#a62062703a8a8aa6caa46a2f0b531ef2c">SetWeeklyResetTime</a>()</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span>    {</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span>        <span class="keywordtype">int</span> year, month, day, hour, minute, second;</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span>        <span class="keywordtype">int</span> weeklyResetHour = <a class="code hl_function" href="../../dd/d94/a08424.html#a0a20d14d2f55a927a3b0eab0623f5cf9">GetExpansionSettings</a>().<a class="code hl_function" href="../../dd/d8e/a03377.html#a02cdd7530681781f6a936cd32af9f2fe">GetQuest</a>().WeeklyQuestResetHour;</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>        <span class="keywordtype">int</span> weeklyResetMinute = <a class="code hl_function" href="../../dd/d94/a08424.html#a0a20d14d2f55a927a3b0eab0623f5cf9">GetExpansionSettings</a>().<a class="code hl_function" href="../../dd/d8e/a03377.html#a02cdd7530681781f6a936cd32af9f2fe">GetQuest</a>().WeeklyQuestResteMinute;</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>        <span class="keywordtype">int</span> current = CF_Date.Now(<a class="code hl_function" href="../../dd/d94/a08424.html#a0a20d14d2f55a927a3b0eab0623f5cf9">GetExpansionSettings</a>().GetQuest().<a class="code hl_variable" href="../../d0/d79/a02117.html#ae68fa45e58fe2cb114610d8f06182d4c">UseUTCTime</a>).GetTimestamp();</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>        CF_Date.TimestampToDate(current, year, month, day, hour, minute, second);</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span> </div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span>        hour = weeklyResetHour;</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>        minute = weeklyResetMinute;</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>        second = 0;</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span> </div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>        <a class="code hl_variable" href="../../d0/de9/a06465.html#a88baee373ed33c7af4d8fa5d690273c0">LastWeeklyReset</a> = CF_Date.CreateDateTime(year, month, day, hour, minute, second).GetTimestamp();</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>    }</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span> </div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno"><a class="line" href="../../d6/d1b/a06469.html#a57949613bf615db2e2f7857361aaa654">   44</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d6/d1b/a06469.html#a57949613bf615db2e2f7857361aaa654">SetDailyResetTime</a>()</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>    {</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>        <span class="keywordtype">int</span> year, month, day, hour, minute, second;</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>        <span class="keywordtype">int</span> dailyResetHour = <a class="code hl_function" href="../../dd/d94/a08424.html#a0a20d14d2f55a927a3b0eab0623f5cf9">GetExpansionSettings</a>().<a class="code hl_function" href="../../dd/d8e/a03377.html#a02cdd7530681781f6a936cd32af9f2fe">GetQuest</a>().DailyQuestResetHour;</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>        <span class="keywordtype">int</span> dailyResetMinute = <a class="code hl_function" href="../../dd/d94/a08424.html#a0a20d14d2f55a927a3b0eab0623f5cf9">GetExpansionSettings</a>().<a class="code hl_function" href="../../dd/d8e/a03377.html#a02cdd7530681781f6a936cd32af9f2fe">GetQuest</a>().DailyQuestResetMinute;</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>        <span class="keywordtype">int</span> current = CF_Date.Now(<a class="code hl_function" href="../../dd/d94/a08424.html#a0a20d14d2f55a927a3b0eab0623f5cf9">GetExpansionSettings</a>().GetQuest().<a class="code hl_variable" href="../../d0/d79/a02117.html#ae68fa45e58fe2cb114610d8f06182d4c">UseUTCTime</a>).GetTimestamp();</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>        CF_Date.TimestampToDate(current, year, month, day, hour, minute, second);</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span> </div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>        hour = dailyResetHour;</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>        minute = dailyResetMinute;</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>        second = 0;</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span> </div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>        <a class="code hl_variable" href="../../d0/de9/a06465.html#a28e3631232f3c41f0875102d6f91d54b">LastDailyReset</a> = CF_Date.CreateDateTime(year, month, day, hour, minute, second).GetTimestamp();</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>    }</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span> </div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno"><a class="line" href="../../d6/d1b/a06469.html#aff6038e42cc2a3a96c5a44ad1076bd50">   59</a></span>    <span class="keywordtype">int</span> <a class="code hl_function" href="../../d6/d1b/a06469.html#aff6038e42cc2a3a96c5a44ad1076bd50">GetLastWeeklyResetTimeDiff</a>()</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>    {</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>        <span class="keywordtype">int</span> currentTime = CF_Date.Now(<a class="code hl_function" href="../../dd/d94/a08424.html#a0a20d14d2f55a927a3b0eab0623f5cf9">GetExpansionSettings</a>().GetQuest().<a class="code hl_variable" href="../../d0/d79/a02117.html#ae68fa45e58fe2cb114610d8f06182d4c">UseUTCTime</a>).GetTimestamp();</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>        <span class="keywordflow">return</span> (currentTime - <a class="code hl_variable" href="../../d0/de9/a06465.html#a88baee373ed33c7af4d8fa5d690273c0">LastWeeklyReset</a>);</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>    }</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span> </div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno"><a class="line" href="../../d6/d1b/a06469.html#a1de616c2968e830f05cdff61d9a4bad7">   65</a></span>    <span class="keywordtype">int</span> <a class="code hl_function" href="../../d6/d1b/a06469.html#a1de616c2968e830f05cdff61d9a4bad7">GetLastDailyResetTimeDiff</a>()</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>    {</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>        <span class="keywordtype">int</span> currentTime = CF_Date.Now(<a class="code hl_function" href="../../dd/d94/a08424.html#a0a20d14d2f55a927a3b0eab0623f5cf9">GetExpansionSettings</a>().GetQuest().<a class="code hl_variable" href="../../d0/d79/a02117.html#ae68fa45e58fe2cb114610d8f06182d4c">UseUTCTime</a>).GetTimestamp();</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>        <span class="keywordflow">return</span> (currentTime - <a class="code hl_variable" href="../../d0/de9/a06465.html#a28e3631232f3c41f0875102d6f91d54b">LastDailyReset</a>);</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>    }</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span> </div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno"><a class="line" href="../../d6/d1b/a06469.html#a8876a497c59286596568bdd12994479c">   71</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d6/d1b/a06469.html#a8876a497c59286596568bdd12994479c">HasWeeklyResetCooldown</a>()</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>    {</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>        <span class="keywordtype">int</span> timedif = <a class="code hl_function" href="../../d6/d1b/a06469.html#aff6038e42cc2a3a96c5a44ad1076bd50">GetLastWeeklyResetTimeDiff</a>();</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>        <span class="keywordflow">if</span> (timedif &lt; <a class="code hl_variable" href="../../d6/d1b/a06469.html#aaec92cabe9ce47dffa1612a5b8467778">WEEK_TIME</a>)</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>            <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span> </div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>    }</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span> </div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno"><a class="line" href="../../d6/d1b/a06469.html#a41796bdabf9107a315618f56324c61d0">   80</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d6/d1b/a06469.html#a41796bdabf9107a315618f56324c61d0">HasDailyResetCooldown</a>()</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>    {</div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>        <span class="keywordtype">int</span> timedif = <a class="code hl_function" href="../../d6/d1b/a06469.html#a1de616c2968e830f05cdff61d9a4bad7">GetLastDailyResetTimeDiff</a>();</div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>        <span class="keywordflow">if</span> (timedif &lt; <a class="code hl_variable" href="../../d6/d1b/a06469.html#a2b950596474fa455a2a744e8d076da8d">DAY_TIME</a>)</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>            <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span> </div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>    }</div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span> </div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno"><a class="line" href="../../d6/d1b/a06469.html#a282bbedf59e00769e1bfc8696733b63d">   89</a></span>    <span class="keyword">static</span> <a class="code hl_class" href="../../d6/d1b/a06469.html">ExpansionQuestPersistentServerData</a> <a class="code hl_function" href="../../d6/d1b/a06469.html#a282bbedf59e00769e1bfc8696733b63d">Load</a>()</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>    {</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>        <span class="keywordtype">bool</span> save;</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>        CF_Log.Info(<span class="stringliteral">&quot;[ExpansionQuestPersistentServerData] Load existing configuration file:&quot;</span> + <a class="code hl_variable" href="../../da/d4a/a02114.html#aee6244dd53cbe87f56ed8888fdd210a6">EXPANSION_QUESTS_PERSISTENT_SERVER_DATA_FILE</a>);</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span> </div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>        <a class="code hl_class" href="../../d6/d1b/a06469.html">ExpansionQuestPersistentServerData</a> data;</div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>        <a class="code hl_class" href="../../d0/de9/a06465.html">ExpansionQuestPersistentServerDataBase</a> dataBase;</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>        JsonFileLoader&lt;ExpansionQuestPersistentServerDataBase&gt;.JsonLoadFile(<a class="code hl_variable" href="../../da/d4a/a02114.html#aee6244dd53cbe87f56ed8888fdd210a6">EXPANSION_QUESTS_PERSISTENT_SERVER_DATA_FILE</a>, dataBase);</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span> </div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>        <span class="keywordflow">if</span> (dataBase.<a class="code hl_variable" href="../../d0/de9/a06465.html#acbd7f84a5493f997ee6165522c95226d">ConfigVersion</a> &lt; <a class="code hl_variable" href="../../d6/d1b/a06469.html#aa4ffca8a2792420d7e2218608628b48b">CONFIGVERSION</a>)</div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>        {</div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>            CF_Log.Info(<span class="stringliteral">&quot;[ExpansionQuestPersistentServerData] Convert existing configuration file:&quot;</span> + <a class="code hl_variable" href="../../da/d4a/a02114.html#aee6244dd53cbe87f56ed8888fdd210a6">EXPANSION_QUESTS_PERSISTENT_SERVER_DATA_FILE</a> + <span class="stringliteral">&quot; to version &quot;</span> + <a class="code hl_variable" href="../../d6/d1b/a06469.html#aa4ffca8a2792420d7e2218608628b48b">CONFIGVERSION</a>);</div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>            data = <span class="keyword">new</span> <a class="code hl_class" href="../../d6/d1b/a06469.html">ExpansionQuestPersistentServerData</a>();<span class="comment"></span></div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span><span class="comment">            //! Copy over old configuration that haven&#39;t changed</span></div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span><span class="comment"></span>            data.<a class="code hl_function" href="../../d6/d1b/a06469.html#ac19e540fc2be384ddde2e5b3f733e04d">CopyConfig</a>(dataBase);</div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>            data.<a class="code hl_variable" href="../../d0/de9/a06465.html#acbd7f84a5493f997ee6165522c95226d">ConfigVersion</a> = <a class="code hl_variable" href="../../d6/d1b/a06469.html#aa4ffca8a2792420d7e2218608628b48b">CONFIGVERSION</a>;</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>            save = <span class="keyword">true</span>;</div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>        }</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>        {</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>            JsonFileLoader&lt;ExpansionQuestPersistentServerData&gt;.JsonLoadFile(<a class="code hl_variable" href="../../da/d4a/a02114.html#aee6244dd53cbe87f56ed8888fdd210a6">EXPANSION_QUESTS_PERSISTENT_SERVER_DATA_FILE</a>, data);</div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>        }</div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span> </div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>        <span class="keywordflow">if</span> (save)</div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>        {</div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>            JsonFileLoader&lt;ExpansionQuestPersistentServerData&gt;.JsonSaveFile(<a class="code hl_variable" href="../../da/d4a/a02114.html#aee6244dd53cbe87f56ed8888fdd210a6">EXPANSION_QUESTS_PERSISTENT_SERVER_DATA_FILE</a>, data);</div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>        }</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span> </div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>        <span class="keywordflow">return</span> data;</div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>    }</div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span> </div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno"><a class="line" href="../../d6/d1b/a06469.html#af59aa6f666e3d5b9204ab698c1b6e0ff">  120</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d6/d1b/a06469.html#af59aa6f666e3d5b9204ab698c1b6e0ff">Save</a>()</div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>    {</div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>        JsonFileLoader&lt;ExpansionQuestPersistentServerData&gt;.JsonSaveFile(<a class="code hl_variable" href="../../da/d4a/a02114.html#aee6244dd53cbe87f56ed8888fdd210a6">EXPANSION_QUESTS_PERSISTENT_SERVER_DATA_FILE</a>, <span class="keyword">this</span>);</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>    }</div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span> </div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno"><a class="line" href="../../d6/d1b/a06469.html#ac19e540fc2be384ddde2e5b3f733e04d">  125</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d6/d1b/a06469.html#ac19e540fc2be384ddde2e5b3f733e04d">CopyConfig</a>(<a class="code hl_class" href="../../d0/de9/a06465.html">ExpansionQuestPersistentServerDataBase</a> dataBase)</div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>    {</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>        <a class="code hl_variable" href="../../d0/de9/a06465.html#a88baee373ed33c7af4d8fa5d690273c0">LastWeeklyReset</a> = dataBase.<a class="code hl_variable" href="../../d0/de9/a06465.html#a88baee373ed33c7af4d8fa5d690273c0">LastWeeklyReset</a>;</div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>        <a class="code hl_variable" href="../../d0/de9/a06465.html#a28e3631232f3c41f0875102d6f91d54b">LastDailyReset</a> = dataBase.<a class="code hl_variable" href="../../d0/de9/a06465.html#a28e3631232f3c41f0875102d6f91d54b">LastDailyReset</a>;</div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>    }</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>};</div>
<div class="ttc" id="aa02114_html_aee6244dd53cbe87f56ed8888fdd210a6"><div class="ttname"><a href="../../da/d4a/a02114.html#aee6244dd53cbe87f56ed8888fdd210a6">EXPANSION_QUESTS_PERSISTENT_SERVER_DATA_FILE</a></div><div class="ttdeci">static const string EXPANSION_QUESTS_PERSISTENT_SERVER_DATA_FILE</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d4a/a02114_source.html#l00022">dayzexpansion_quest_constants.c:22</a></div></div>
<div class="ttc" id="aa02117_html_ae68fa45e58fe2cb114610d8f06182d4c"><div class="ttname"><a href="../../d0/d79/a02117.html#ae68fa45e58fe2cb114610d8f06182d4c">UseUTCTime</a></div><div class="ttdeci">bool UseUTCTime</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d79/a02117_source.html#l00037">expansionquestsettings.c:37</a></div></div>
<div class="ttc" id="aa03377_html_a02cdd7530681781f6a936cd32af9f2fe"><div class="ttname"><a href="../../dd/d8e/a03377.html#a02cdd7530681781f6a936cd32af9f2fe">ExpansionSettings::GetQuest</a></div><div class="ttdeci">ExpansionQuestSettings GetQuest(bool checkLoaded=true)</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d78/a08448_source.html#l00044">expansionsettings.c:44</a></div></div>
<div class="ttc" id="aa06465_html"><div class="ttname"><a href="../../d0/de9/a06465.html">ExpansionQuestPersistentServerDataBase</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d90/a02177_source.html#l00013">expansionquestpersistentserverdata.c:14</a></div></div>
<div class="ttc" id="aa06465_html_a28e3631232f3c41f0875102d6f91d54b"><div class="ttname"><a href="../../d0/de9/a06465.html#a28e3631232f3c41f0875102d6f91d54b">ExpansionQuestPersistentServerDataBase::LastDailyReset</a></div><div class="ttdeci">int LastDailyReset</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d90/a02177_source.html#l00017">expansionquestpersistentserverdata.c:17</a></div></div>
<div class="ttc" id="aa06465_html_a88baee373ed33c7af4d8fa5d690273c0"><div class="ttname"><a href="../../d0/de9/a06465.html#a88baee373ed33c7af4d8fa5d690273c0">ExpansionQuestPersistentServerDataBase::LastWeeklyReset</a></div><div class="ttdeci">int LastWeeklyReset</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d90/a02177_source.html#l00016">expansionquestpersistentserverdata.c:16</a></div></div>
<div class="ttc" id="aa06465_html_acbd7f84a5493f997ee6165522c95226d"><div class="ttname"><a href="../../d0/de9/a06465.html#acbd7f84a5493f997ee6165522c95226d">ExpansionQuestPersistentServerDataBase::ConfigVersion</a></div><div class="ttdeci">int ConfigVersion</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d90/a02177_source.html#l00015">expansionquestpersistentserverdata.c:15</a></div></div>
<div class="ttc" id="aa06469_html"><div class="ttname"><a href="../../d6/d1b/a06469.html">ExpansionQuestPersistentServerData</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d90/a02177_source.html#l00020">expansionquestpersistentserverdata.c:21</a></div></div>
<div class="ttc" id="aa06469_html_a1de616c2968e830f05cdff61d9a4bad7"><div class="ttname"><a href="../../d6/d1b/a06469.html#a1de616c2968e830f05cdff61d9a4bad7">ExpansionQuestPersistentServerData::GetLastDailyResetTimeDiff</a></div><div class="ttdeci">int GetLastDailyResetTimeDiff()</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d90/a02177_source.html#l00065">expansionquestpersistentserverdata.c:65</a></div></div>
<div class="ttc" id="aa06469_html_a282bbedf59e00769e1bfc8696733b63d"><div class="ttname"><a href="../../d6/d1b/a06469.html#a282bbedf59e00769e1bfc8696733b63d">ExpansionQuestPersistentServerData::Load</a></div><div class="ttdeci">static ExpansionQuestPersistentServerData Load()</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d90/a02177_source.html#l00089">expansionquestpersistentserverdata.c:89</a></div></div>
<div class="ttc" id="aa06469_html_a2b950596474fa455a2a744e8d076da8d"><div class="ttname"><a href="../../d6/d1b/a06469.html#a2b950596474fa455a2a744e8d076da8d">ExpansionQuestPersistentServerData::DAY_TIME</a></div><div class="ttdeci">static int DAY_TIME</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d90/a02177_source.html#l00025">expansionquestpersistentserverdata.c:25</a></div></div>
<div class="ttc" id="aa06469_html_a41796bdabf9107a315618f56324c61d0"><div class="ttname"><a href="../../d6/d1b/a06469.html#a41796bdabf9107a315618f56324c61d0">ExpansionQuestPersistentServerData::HasDailyResetCooldown</a></div><div class="ttdeci">bool HasDailyResetCooldown()</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d90/a02177_source.html#l00080">expansionquestpersistentserverdata.c:80</a></div></div>
<div class="ttc" id="aa06469_html_a57949613bf615db2e2f7857361aaa654"><div class="ttname"><a href="../../d6/d1b/a06469.html#a57949613bf615db2e2f7857361aaa654">ExpansionQuestPersistentServerData::SetDailyResetTime</a></div><div class="ttdeci">void SetDailyResetTime()</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d90/a02177_source.html#l00044">expansionquestpersistentserverdata.c:44</a></div></div>
<div class="ttc" id="aa06469_html_a62062703a8a8aa6caa46a2f0b531ef2c"><div class="ttname"><a href="../../d6/d1b/a06469.html#a62062703a8a8aa6caa46a2f0b531ef2c">ExpansionQuestPersistentServerData::SetWeeklyResetTime</a></div><div class="ttdeci">void SetWeeklyResetTime()</div><div class="ttdoc">Week in seconds.</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d90/a02177_source.html#l00029">expansionquestpersistentserverdata.c:29</a></div></div>
<div class="ttc" id="aa06469_html_a8876a497c59286596568bdd12994479c"><div class="ttname"><a href="../../d6/d1b/a06469.html#a8876a497c59286596568bdd12994479c">ExpansionQuestPersistentServerData::HasWeeklyResetCooldown</a></div><div class="ttdeci">bool HasWeeklyResetCooldown()</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d90/a02177_source.html#l00071">expansionquestpersistentserverdata.c:71</a></div></div>
<div class="ttc" id="aa06469_html_aa4ffca8a2792420d7e2218608628b48b"><div class="ttname"><a href="../../d6/d1b/a06469.html#aa4ffca8a2792420d7e2218608628b48b">ExpansionQuestPersistentServerData::CONFIGVERSION</a></div><div class="ttdeci">static const int CONFIGVERSION</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d90/a02177_source.html#l00022">expansionquestpersistentserverdata.c:22</a></div></div>
<div class="ttc" id="aa06469_html_aaec92cabe9ce47dffa1612a5b8467778"><div class="ttname"><a href="../../d6/d1b/a06469.html#aaec92cabe9ce47dffa1612a5b8467778">ExpansionQuestPersistentServerData::WEEK_TIME</a></div><div class="ttdeci">static int WEEK_TIME</div><div class="ttdoc">Day in seconds.</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d90/a02177_source.html#l00027">expansionquestpersistentserverdata.c:27</a></div></div>
<div class="ttc" id="aa06469_html_ac19e540fc2be384ddde2e5b3f733e04d"><div class="ttname"><a href="../../d6/d1b/a06469.html#ac19e540fc2be384ddde2e5b3f733e04d">ExpansionQuestPersistentServerData::CopyConfig</a></div><div class="ttdeci">void CopyConfig(ExpansionQuestPersistentServerDataBase dataBase)</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d90/a02177_source.html#l00125">expansionquestpersistentserverdata.c:125</a></div></div>
<div class="ttc" id="aa06469_html_af59aa6f666e3d5b9204ab698c1b6e0ff"><div class="ttname"><a href="../../d6/d1b/a06469.html#af59aa6f666e3d5b9204ab698c1b6e0ff">ExpansionQuestPersistentServerData::Save</a></div><div class="ttdeci">void Save()</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d90/a02177_source.html#l00120">expansionquestpersistentserverdata.c:120</a></div></div>
<div class="ttc" id="aa06469_html_aff6038e42cc2a3a96c5a44ad1076bd50"><div class="ttname"><a href="../../d6/d1b/a06469.html#aff6038e42cc2a3a96c5a44ad1076bd50">ExpansionQuestPersistentServerData::GetLastWeeklyResetTimeDiff</a></div><div class="ttdeci">int GetLastWeeklyResetTimeDiff()</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d90/a02177_source.html#l00059">expansionquestpersistentserverdata.c:59</a></div></div>
<div class="ttc" id="aa08424_html_a0a20d14d2f55a927a3b0eab0623f5cf9"><div class="ttname"><a href="../../dd/d94/a08424.html#a0a20d14d2f55a927a3b0eab0623f5cf9">GetExpansionSettings</a></div><div class="ttdeci">static ExpansionSettings GetExpansionSettings()</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/d94/a08424_source.html#l00254">expansionsettings.c:254</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_6127fff2da0a20e2dc2cd9302c584350.html">DayzExpansion</a></li><li class="navelem"><a class="el" href="../../dir_1aeb20201abd12b8e4cbe340a915686e.html">Quests</a></li><li class="navelem"><a class="el" href="../../dir_29e5a841f4af4b583623a745e009ef31.html">Scripts</a></li><li class="navelem"><a class="el" href="../../dir_6229eaf44b730d10fc037c21be0cc9d2.html">4_world</a></li><li class="navelem"><a class="el" href="../../dir_41bb0a1ba7a249856ef624b7024ff764.html">dayzexpansion_quests</a></li><li class="navelem"><a class="el" href="../../dir_2cb013c5fea97d25b3c5e425100cdce5.html">systems</a></li><li class="navelem"><a class="el" href="../../dir_eb26c162496b02eac2af2f3f20c5c189.html">quests</a></li><li class="navelem"><a class="el" href="../../d3/d90/a02177.html">expansionquestpersistentserverdata.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
